program ServicesAutoRestart;

{$APPTYPE CONSOLE}

uses
  Windows,
  Classes,
  SysUtils,
  INIFiles,
  Registry;

type
  TFailureActionsBuffer = array [0..43] of Byte;
const
DefaultFailureActionsBuffer: TFailureActionsBuffer =
  (00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 03, 00, 00, 00, $41, 00, $43,
  00, 01, 00, 00, 00, 00, 00, 00, 00, 01, 00, 00, 00, 00, 00, 00, 00, 01, 00, 00, 00, 00, 00, 00, 00);
var
  i: Integer;
  Reg, ServiceInfo: TRegistry;
  Keys: TStringList;
  ServiceName: String;
  Buffer: array [0..43] of Byte;
begin
  try
    { TODO -oUser -cConsole Main : Insert code here }
    Reg := TRegistry.Create;
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    ServiceInfo := TRegistry.Create;
    ServiceInfo.RootKey := HKEY_LOCAL_MACHINE;

    Keys := TStringList.Create;
    if Reg.OpenKey('SYSTEM\CurrentControlSet\Services\', FALSE) then
    begin
      Reg.GetKeyNames(Keys);
      for I := 0 to Keys.Count - 1 do
        if ServiceInfo.OpenKey(Format('SYSTEM\CurrentControlSet\Services\%s', [Keys[i]]),
          FALSE) then
        begin
          if ServiceInfo.ValueExists('Description') then
            if ServiceInfo.ValueExists('DisplayName') then
              if ServiceInfo.ValueExists('ObjectName') then
              begin
                ServiceName := ServiceInfo.ReadString('DisplayName');
                if (ServiceInfo.ValueExists('FailureActions')) then
                  try
                    ServiceInfo.ReadBinaryData('FailureActions', Buffer, SizeOf(Buffer));
                    Buffer[20] := 1;
                    Buffer[28] := 1;
                    Buffer[36] := 1;
                    ServiceInfo.WriteBinaryData('FailureActions', Buffer, SizeOf(Buffer));
                    AnsiToOem(Pchar(ServiceName), Pchar(ServiceName));
                    writeln(Format('%s patched', [ServiceName]));
                  except
                    writeln(Format('%s not patched', [ServiceName]));
                  end
                else
                  try
                    ServiceInfo.WriteBinaryData('FailureActions', DefaultFailureActionsBuffer,
                      SizeOf(DefaultFailureActionsBuffer));
                    AnsiToOem(Pchar(ServiceName), Pchar(ServiceName));
                    writeln(Format('%s patched', [ServiceName]));
                  except
                    writeln(Format('%s not patched', [ServiceName]));
                  end;

              end;
          ServiceInfo.CloseKey;
        end;
      Reg.CloseKey;
      ReadLn;
    end;
  except
    on E: Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
  FreeAndNil(Keys);
  FreeAndNil(Reg);

  //OpenService
end.
